<template>
  <v-container class="fill-height" fluid>
    <v-row class="fill-height" align="center" justify="center">
      <v-col cols="6">
        <v-card class="elevation-12">
          <v-toolbar dark color="primary">
            <v-toolbar-title>Login form</v-toolbar-title>
          </v-toolbar>
          <v-card-text>
            <v-form>
              <v-text-field
                v-model="username"
                name="login"
                label="Login"
                type="text"
                @keydown="resetWarning"
                @keydown.prevent.enter="submit"
              ></v-text-field>
              <v-text-field
                v-model="password"
                id="password"
                :append-icon="displayPassword ? 'mdi-eye' : 'mdi-eye-off'"
                name="password"
                label="Password"
                :type="displayPassword ? 'text' : 'password'"
                @click:append="displayPassword = !displayPassword"
              ></v-text-field>
              <v-alert dense :type="alertType" v-show="showAlert">
                <v-progress-circular
                  indeterminate
                  size="20"
                  width="3"
                  v-if="loading"
                />
                {{ alertMessage }}
              </v-alert>
            </v-form>
            <v-btn color="primary" @click="submit">Login</v-btn>
          </v-card-text>
          <v-card-actions>
            <v-spacer></v-spacer>
            <router-link class="mt-8 d-block" :to="{ name: 'register' }">
              Don't have an account? Register here
            </router-link>
          </v-card-actions>
        </v-card>
      </v-col>
    </v-row>
  </v-container>
</template>

<script lang="ts">
import type { ContextualTypes } from "@/ts/types/ContextualTypes";
import type { Ref } from "vue";
import { defineComponent, ref } from "vue";
import { useRouter } from "vue-router";

import { useUserStore } from "@/stores/user";

export default defineComponent({
  setup() {
    const user = useUserStore();

    const router = useRouter();
    const username: Ref<string> = ref("");
    const password: Ref<string> = ref("");
    const displayPassword: Ref<boolean> = ref(false);
    const showAlert: Ref<boolean> = ref(false);
    const loading: Ref<boolean> = ref(false);
    const alertType: Ref<ContextualTypes> = ref("error");
    const alertMessage: Ref<string> = ref("");

    const isFormValid = (): boolean => {
      switch (true) {
        case !password.value.trim() && !username.value.trim():
          showAlert.value = true;
          alertMessage.value = "Username and password missing";
          alertType.value = "error";
          return false;
        case !username.value.trim():
          showAlert.value = true;
          alertMessage.value = "Missing username";
          alertType.value = "error";
          return false;
        case !password.value.trim():
          showAlert.value = true;
          alertMessage.value = "Missing password";
          alertType.value = "error";
          return false;
      }

      showAlert.value = false;
      alertMessage.value = "";
      return true;
    };

    const submit = () => {
      const formIsValid = isFormValid();

      let isLoggedIn = false;

      if (formIsValid) {
        user.login(username.value, password.value);
        isLoggedIn = true;
      }

      showAlert.value = true;

      alertType.value = isLoggedIn ? "success" : "error";

      if (!isLoggedIn) return;

      loading.value = true;

      router.push("/");
    };

    /**
     * Resets the alert variables and hides the alert.
     */
    const resetWarning = () => {
      showAlert.value = false;
      alertType.value = "error";
      alertMessage.value = "";
    };

    return {
      displayPassword,
      resetWarning,
      username,
      password,
      showAlert,
      alertType,
      alertMessage,
      loading,
      submit,
    };
  },
});
</script>

<style></style>
